use crate::kind_src::KindsSrc;

pub const YAML_KINDS_SRC: KindsSrc = KindsSrc {
    punct: &[
        (":", "COLON"),
        (",", "COMMA"),
        ("{", "L_CURLY"),
        ("}", "R_CURLY"),
        ("[", "L_BRACK"),
        ("]", "R_BRACK"),
        ("-", "DASH"),
        ("%", "PERCENT"),
        ("*", "STAR"),
        ("#", "HASH"),
        ("!", "BANG"),
        ("@", "AT"),
        ("<<", "SHL"),
        ("&", "AMP"),
        ("|", "PIPE"),
        (">", "R_ANGLE"),
        ("~", "TILDE"),
        ("`", "BACKTICK"),
        ("---", "DOC_START"),
        ("...", "DOC_END"),
    ],
    keywords: &["null"],
    literals: &[
        "YAML_STRING_VALUE",
        "YAML_NUMBER_VALUE",
        "YAML_BOOLEAN_VALUE",
        "YAML_NULL_VALUE",
        "YAML_BLOCK_VALUE",
        "YAML_IDENTIFIER",
    ],
    tokens: &["NEWLINE", "WHITESPACE", "IDENT", "COMMENT"],
    nodes: &[
        "YAML_ROOT",
        "YAML_DOCUMENT_LIST",
        "YAML_DOCUMENT",
        "YAML_ARRAY_INLINE",
        "YAML_ARRAY_INLINE_LIST",
        "YAML_OBJECT",
        "YAML_OBJECT_MEMBER",
        "YAML_OBJECT_MEMBER_LIST",
        "YAML_ARRAY",
        "YAML_ARRAY_ITEM",
        "YAML_ARRAY_ITEM_LIST",
        "YAML_BLOCK_LITERAL",
        "YAML_BLOCK_FOLDED",
        // Bogus nodes
        "YAML_BOGUS",
        "YAML_BOGUS_VALUE",
    ],
};
